
/*!\file
 * \brief            SpaceWire.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */
#include "spacewire_test.h"

/**
 * \brief  SpaceWire
 *
 *     SpaceWire
 *  
 *     SpaceWire   SpaceWire1  SpaceWire2
 *
 *     2- :
 *                    -    SPW1  SPW2
 *                    -    SPW2  SPW1
 *      :
 *                    -  SpaceWire
 *                    -  SpaceWire
 *                    -   
 *                    -  
 *                    -   -   
 *                  e ,    
 *                  -   
 *       
 *      ,    .
 *          Workspace: 
 *                      - periph_spacewire_ram -    
 *                      - periph_spacewire_ext -       
 */   
void main()
{
    SystemInit2();                                                               //  
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
    
    while (1)
    SpacewireInternal_Test();                                                   //  Spacewire
  
    while(1) 
    {
        DBG_TX_Process();                                                       //  ,    ,   UART
    }
}
