
/*!\file
 * \brief          .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */


#include "watchdog_test.h"

const uint32_t sys_freq = 50000000;                                             //  
char dbg_buffer[256];                                                           //   
uint32_t count = 0;                                                             // 

/**
 * @brief     
 */
void Watchdog_IRQ(void)
{
    if (count < 10) 
    {           
        PRINT("    : %d", count++);
        WDT_IntClr(WDT);                                                        //   ,              
        DBG_TX_Flush();                                                         //   ,    ,   UART
    } 
    else 
    {
        PRINT("  ");
        count++;
        NVIC_DisableIRQ(1);
        WDT_IntDisable(WDT);
        PRINT ("  !");
    }
             
}

void Test_Watchdog()
{
    PRINT("  ");
    
    WDT_SetValue(WDT,160000000);                                                //      
    WDT_IntEnable(WDT);                                                         //      
    NVIC_EnableIRQ(Watchdog,1);                                                 //       
    WDT_HWResetEnable(WDT);                                                     //    
}
