/*!\file
 * \brief           - M29W800DT45N.
 *
 * Copyright(C)   , 2015
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include <stdlib.h> 

#include "flash_test.h"
#include "mem_test.h"
#include "flash.h"   


#define FLASHBUFFSIZE 256

/*    -    */
void FLASH_SetReadMode(void)
{
        FLASH_PROG_REG0 = 0xAAAA;
        FLASH_PROG_REG1 = 0x5555;
        FLASH_PROG_REG0 = 0xF0F0; 
}

/*   -.    0xFFFF */
void FLASH_EraseChip(void)
{
        FLASH_PROG_REG0 = 0xAAAA;
        FLASH_PROG_REG1 = 0x5555;
        FLASH_PROG_REG0 = 0x8080;
        FLASH_PROG_REG0 = 0xAAAA;
        FLASH_PROG_REG1 = 0x5555;
        FLASH_PROG_REG0 = 0x1010;
}

/*   16-   - -. */
void FLASH_Write16Bits(uint16_t addr, uint16_t data)
{
    FLASH_PROG_REG0 = 0xAAAA;
    FLASH_PROG_REG1 = 0x5555;
    FLASH_PROG_REG0 = 0xA0A0; 
    *(volatile uint16_t *)(addr)= data;  
}  


/*       () */
void FLASH_WriteFirmware(uint8_t *firmware_data, uint16_t byte_size)
{
  FLASH_EraseChip();
  for(uint16_t i = 0; i <= byte_size; i+=2) {
    FLASH_Write16Bits(i, *((uint16_t *)(firmware_data+i)));
  } 
}


uint8_t Flash_Test(void)
{
    uint8_t result = 0;
    uint32_t Man, Dev;
    uint8_t* srcbuff;

    PRINTSTREAM("\n");
    PRINT(" Flash"); 

    FLASH_AutoSelectMode(&Man, &Dev);
    FLASH_ReadResetMode();
    
    if ((Man !=0x0) || (Dev != 0xD7D7)) 
    {  
        result = 1;
        
        PRINT("    Flash");    
        return result=1;
    }

    FLASH_ChipErase();
 
    result=TestPage();
    
    PRINT("  ");

    FLASH_ReadResetMode();
     
    if (!result)
    {
        PRINT(" Flash  !");
    }
    else
    {
        PRINT(" Flash   !");
    }    
    return result;  
}