
/*!\file
 * \brief            Manchester.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */
#include "manchester_test.h"


/**
 * \brief  MKPD
 *
 *     MKPD
 *    MKPD     MKPD  
 *
 *      :
 *                    -        
 *                    -  16 ,          
 *                    -    -     
 *                    -  
 *                    -  
 *                    -   -     
 *                  e     
 *                  -   
 *       
 *      ,    .
 *          Workspace: 
 *                      - periph_manchester_ram -    
 *                      - periph_manchester_ext -    
 */   
void main()
{
    SystemInit();                                                               //  
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
    
    MKPD_Test();                                                                //  MKPD
  
    while(1) 
    {
        DBG_TX_Process();                                                       //  ,    ,   UART
    }
}