/*!\file
* \brief       UART.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */
#include "uart_test.h"

/**
 * \brief  UART
 *
 *     UART
 *   UART2   rx  tx (2  3 ).
 *     3- :
 *                    -  
 *                    -   
 *                    -   DMA
 *       
 *      :
 *                    -  UART
 *                    -  UART
 *                    -   tx  1...255
 *                    -  
 *                    -   -   rx  tx
 *                  e rx = tx    
 *                  -   
 *       
 *      ,    .
 *          Workspace: 
 *                      - periph_uart_ram -    
 *                      - periph_uart_ext -    
 */
void main()
{
    SystemInit();                                                               //   
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
    
    UART_Test();                                                                //  UART
 
    while(1) 
    {
        DBG_TX_Process();                                                       //  ,    ,   UART
    }
}